;;; behaviour.scm - Clement JONQUET - PhD student in Compuer Science - LIRMM - September 2003 ;;;

;;; This file contains the default known procedures ;;;

;;; This file is loaded after an Agent creation and these functions are added to its global-env

; ask-user function ;
; Run a user interface for process variables using in a service generation. These variables are listed as (identifiant type comment)

(define (ask-user list-var)
  (begin (newline)(display "\tService generation you can interact on:")(newline)(newline)
	 (mapper (lambda (x)
		   (display "\t")(display (car x))
		   (display "\t TYPE: ")(display (car (cdr x)))
		   (display "\t COMMENT: ")(display (car (cdr (cdr x))))(newline))
		 list-var)
	 (display "Command: ")
	 (let ((command (read)))
	   (if (eq? command 'exit)
	       (begin (display "End of Generation")(newline)(void))
	       (process-user-answer command)))))

; Remark : The function process-user-answer exists in an Agent environment and it is modified for each services. It specifies what an Agent should do with the user entrances. By default it is:

(define (process-user-answer command)
  (display "Sorry, there is no definition for this service"))

; answer-user function ;
; Print to the user the answer produced by a service in a particular way. list-var is construct as a list of (identifiant valeur)

(define (answer-user list-var list-var2)
  (display "The proposition is: ")
  (mapper (lambda (x) (display (car x))(display ": ")(display (car (cdr x)))(display ", ")) list-var)
  (ask-user list-var2))

