;;; evalstudent.scm - Clement JONQUET - PhD student in Compuer Science - LIRMM - September 2003 ;;;

; This file gives the specific interpreter for the teacher, This allows the interpreter described in simple.scm to interpret kqmlmsg.

;;; kqmlmsg process ;;;

(define kqmlmsg? (test-tag 'kqmlmsg))

(define (make-kqmlmsg p s r c)
  (list 'kqmlmsg p s r c))
 
(define (performative kqmlmsg) (car (cdr kqmlmsg)))
(define (sender kqmlmsg) (car (cdr (cdr kqmlmsg))))
(define (receiver kqmlmsg) (car (cdr (cdr (cdr kqmlmsg)))))
(define (content kqmlmsg) (car (cdr (cdr (cdr (cdr kqmlmsg))))))

;;; evaluate procedure ;;;

(set! ambevaluate
  (lambda (e r ks kf)
;    (newline)(display "Evaluate de : ")(display e)(newline)
    ((if (constant? e) 
	 ambevaluate-constant 
     (if (variable? e) 
	 ambevaluate-variable 
     (if (quasiquote? e)
	 ambevaluate-quasiquote
     (if (if? e)
	 ambevaluate-if
     (if (assignment? e) 
	 ambevaluate-assignment
     (if (define? e)
	 ambevaluate-define
     (if (let? e)
	 ambevaluate-let
     (if (begin? e)
	 ambevaluate-begin
     (if (amb? e)
	 ambevaluate-amb
     (if (kqmlmsg? e)
	 ambevaluate-kqmlmsg
     (if (abstraction? e) 
	 ambevaluate-abstraction
	 ambevaluate-combination)))))))))))
     e r ks kf)))

; Process kqmlmsg, return a list of messages or a data...

(define (ambevaluate-kqmlmsg e r ks kf)
  (let ((performative (performative e))
	(sender (sender e))
	(receiver (receiver e))
	(content (content e))
	(interpreter ambevaluate))
    
      (if (eq? performative 'assertion)
	  (interpreter content r 
		       (lambda (val kf2) (ks (list (make-kqmlmsg 'ack receiver sender val)) kf2))
		       kf)
      (if (eq? performative 'request)
	  (interpreter content r 
		       (lambda (val kf2) (ks (list (make-kqmlmsg 'answer receiver sender val)) kf2))
		       kf)
      (if (eq? performative 'order)
	  (interpreter content r 
		       (lambda (val kf2) (ks (list (make-kqmlmsg 'executed receiver sender val)) kf2))
		       kf)
      (if (eq? performative 'ack) 'ok
      (if (eq? performative 'answer) (ks (analyze-answer sender receiver content) kf) 
      (if (eq? performative 'executed) (ks (analyze-answer sender receiver content) kf)
	  ;Else 
	  (ks (list (make-kqmlmsg 'answer receiver sender `(no-such-performative ,performative))) kf)))))))))

(define (analyze-answer sen rec con)
  (if (list? con)
      (if (eq? (car con) 'no-such-performative)
	  ;Call performative-to-learn function
	  (performative-to-learn sen rec (car (cdr con)))
	  ;Else
	  (begin (display "Unknown performative ")(display (car (cdr con)))(display " and no method to teach it")
		 con))
      con))

(define (performative-to-learn sender receiver unknowperform)
  (list (list 'kqmlmsg 'answer receiver sender '(sorry))))
