;;; ambsimpleobj.scm - Clement JONQUET - PhD student in Compuer Science - LIRMM - September 2003 ;;;

; This file describe the simpleobj agent and gives a few procedure to process obect in Scheme and how to make this agent communicate

;;; The ambsimpleobj obect definition's procedure ;;;

(define (simpleobj)
  (let ((super (new-part object))
	(self ()))

    ;Attributs
    (let ((name 'n)                     ; name
	  ;Attention a empty-env peut etre utiliser copy-env
	  (globalEnv empty-env)         ; global environment
	  (globalInter ambevaluate)     ; global interpreter (frame in the env)
	  (other ())                    ; set of frame (name, localenv)
	  (fileMsgIn ())                ; reception Message's file (FIFO)
	  (fileMsgOut ())               ; outgoing Message's file (FILO and FIFO)
	  (conversation ()))            ; list of current conversation    
      
      ;Constructor
      (define (new1 n)
	;Initialization of globalEnv (primitives...)
	(initializeGlobalEnv)
	;Simple interpreter loading
	(loadFileObj1 "../simple.scm")
	;AmbSimple interpreter loading
	(loadFileObj1 "../ambsimple.scm")
	;globalInter changing, to consider now the one stored in globalEnv
	;the globalInter is now a procedure typed as a compound....
	;(print-proc (cdr (get-pair 'ambevaluate globalEnv return (lambda () ()))))
	;(display "globalenv ds simpleobj :")(print-env globalEnv)
	(setGlobalInter (cdr (get-pair 'ambevaluate globalEnv return (lambda () ()))))
	(set! name n))
            
      ;Accessor
      (define (getName) name)
      (define (setName n) (set! name n))
      (define (getGlobalInter) globalInter)
      (define (setGlobalInter function) (set! globalInter function))
      (define (getGlobalEnv) globalEnv)
      (define (setGlobalEnv env) (set! globalEnv env))
      (define (getInter n)
	(cdr (get-pair 'ambevaluate (getEnv n) return (lambda () ()))))
      (define (getEnv n) (car (cdr (assq n other))))
      (define (setInter n inter)
	(define (foo list) 
	  (if (eq? n (car (car list)))
	      (set-car! list ('n inter (getEnv n)))
	      (foo (cdr list)))
	  (foo other)))
      (define (setEnv n env)
	(define (foo list) 
	  (if (eq? n (car (car list)))
	      (set-car! list ('n env))
	      (foo (cdr list)))
	  (foo other)))

      ;Environment process
      (define (extendGlobalEnv item)
	(if (null? globalEnv)
	    (set! globalEnv (cons item globalEnv))
	    (set-cdr! globalEnv (cons item (cdr globalEnv)))))

      (define (initializeGlobalEnv)
	(set! globalEnv 
	      (extend empty-env (primitive-identifiers) (map make-primitive (primitive-identifiers))))) 

      ;File loading, add something in the globalEnv
      
      ;loadFileObj1 load a file before the globalInter is changed
      (define (loadFileObj1 file)
	((lambda (port) 
	   ((lambda (loop) 
	      (set! loop 
		    (lambda (v) 
		      (if (eof-object? v)
			  (begin (close-input-port port) '(*. *))
			  (globalInter v 
				       globalEnv
				       (lambda (ignore kignore) (loop (read port)))
				       (lambda () (display "Erreur lors du chargement..."))))))
	      (loop (read port)))
	    '*))
	 (open-input-file file)))

      ;loadFileObj2 load a file after (when globalInter is a procedure stored in globalEnv)
      (define (loadFileObj2 file)
	((lambda (port)
	   ((lambda (loop) 
	      (set! loop 
		    (lambda (v)
		      (if (eof-object? v)
			  (begin (close-input-port port) '(*. *))
			  (apply-procedure globalInter
					   (list v
						 globalEnv
						 '(compound (val kf) (val) ())
						 '(compound () () ()))
					   (lambda (val) (display val) (loop (read port)))))))		
	      (loop (read port)))
	    '*))
	 (open-input-file file)))

      ;Files process
      (define (emptyFileMsgIn?)
	(null? fileMsgIn))
      (define (pushFileMsgIn kqmlmsg) 
	(set! fileMsgIn (cons kqmlmsg fileMsgIn)))
      (define (popFileMsgIn)
	(let ((fileMsgIn-1 (reverse fileMsgIn)))
	  (if (null? fileMsgIn-1)   
	      ()
	      (begin (set! fileMsgIn (reverse (cdr (reverse fileMsgIn))))
		     (car fileMsgIn-1)))))
      
      (define (emptyFileMsgOut?)
	(null? fileMsgOut))
      (define (pushFileMsgOut kqmlmsg) 
	(set! fileMsgOut (cons kqmlmsg fileMsgOut)))
      (define (popFileMsgOut)
	(let ((fileMsgOut-1 (reverse fileMsgOut)))
	  (if (null? fileMsgOut-1)   
	      ()
	      (begin (set! fileMsgOut (reverse (cdr (reverse fileMsgOut))))
		     (car fileMsgOut-1)))))
		   
      ;Add an other, that means add an (object localenv) ds other... the local interpreter is included in the localenv

      (define (addOther n) 
	(addConversation n)
	(extendGlobalEnv `(current-conversations ,conversation))
	(set! other (cons (list (send n 'getName ()) (copy-env globalEnv)) other)))

;      (define (addOther n) 
;	(let ((newenv empty-env))
;	  (define (copyItem x)
;	    (if (list? x)
;		(if (eq? 'compound (2nd x))
;		    (apply-procedure globalInter
;				     (list (append (list 'define 
;							 (append (list (1st x)) (3rd x)))
;						   (4th x))
;					   newenv
;					   '(compound (val kf) (val) ())
;					   '(compound () () ()))
;				     (lambda (val) val))
;		    x)
;		x))
;	  (let ((goodenv (map copyItem globalEnv)))
;	    (define (clean env)
;	      (if (null? env)
;		  ()
;		  (if (equal? (car env) (void))
;		      (clean (cdr env))
;		      (cons (car env) (clean (cdr env))))))
;	    (set! goodenv (clean goodenv))
;	    (set-cdr! newenv (append goodenv (cdr newenv)))
;;	    (print-env newenv)
;	    (set! other (cons (list (send n 'getName ()) newenv) other)))))
	    
      ;A refaire...
      (define (addOtherFrom n from)
	(set! other (cons (list n (getInter from) (getEnv from)))))

      ;Conversation's traitement
      (define (getConversation) conversation)
      (define (addConversation obj)
	(set! conversation (cons obj conversation)))
	
      ;REPL loop and message's traitement
      (define (listenObj)
	(display "Agent ")(display (getName)) (display " in LISTEN : ")
	(let ((kqmlmsg (popFileMsgIn)))
	  (if (null? kqmlmsg)
	      (begin (display "No message...."))
	      (begin (display "One message....")(newline)(readObj kqmlmsg)))))
      
      (define  (readObj kqmlmsg)
	(display "Agent ")(display (getName)) (display " in READ : ")
	(print-kqmlmsg kqmlmsg)(newline)
	(evalObj kqmlmsg))
      
      ;avant
      (define (evalObj kqmlmsg)
	(display "Agent ")(display (getName)) (display " in EVAL : ")(display "...")(newline)
	(apply-procedure (getInter (send (sender kqmlmsg) 'getName ()))
			 (list (parser kqmlmsg)
			       (getEnv (send (sender kqmlmsg) 'getName ()))
			       '(compound (val kf) (val) ())
			       '(compound () () ()))
			 printObj))

      ;apres
;      (define (evalObj kqmlmsg)
;	(define (internal-loop try-again)
;	  (if (try-again? kqmlmsg)
;	      (try-again)
;	      (begin (display "Agent ")(display (getName)) (display " in EVAL : ")(display "...")
;		     (display "Starting a new problem...")(newline)
;		     (apply-procedure (getInter (send (sender kqmlmsg) 'getName ()))
;				      (list (parser kqmlmsg)
;					    (getEnv (send (sender kqmlmsg) 'getName ()))
;					    '(compound (val next-alternative)
;						       (val) ())
;					    '(compound () () ()))
;				      printObj))

      (define (printObj exp)
	(display "Agent ")(display (getName)) (display " in PRINT : ")
	(if (and (list? exp) (list? (car exp)) (kqmlmsg? (car exp)))
	    ;If the result is a list (that means a list of messages)
	    (map (lambda (x) (print-kqmlmsg x)(newline)(sendmessage x)) (reverse exp))
	    ;Else
	    (process-answer exp)))
    
      (define (process-answer exp)
	(display "Received and analize result : ") (display exp)(newline)
	(if (emptyFileMsgOut?)
	    (display "No more messages...") 
	    (sendmessage (popFileMsgOut))))
      
      (define (parser kqmlmsg) 
	(let ((content (content kqmlmsg)))
	  (define (foo c)
	    (if (pair? c)
		(cons (foo (car c)) (foo (cdr c)))
		(if (eq? c 'goodenv)
		    `',(getEnv (send (sender kqmlmsg) 'getName ()))
		    (if (eq? c 'goodeval)
			`',(getInter (send (sender kqmlmsg) 'getName ()))
			c))))
	  `(kqmlmsg ,(performative kqmlmsg) ,(sender kqmlmsg) ,(receiver kqmlmsg) ,(foo content))))
           		     
      (define (dispatch message) 
	(if (eq? message 'new1) new1
	(if (eq? message 'getName) getName
	(if (eq? message 'setName) setName
	(if (eq? message 'getGlobalInter) getGlobalInter
	(if (eq? message 'setGlobalInter) setGlobalInter
	(if (eq? message 'getGlobalEnv) getGlobalEnv
	(if (eq? message 'setGlobalEnv) setGlobalEnv
	(if (eq? message 'getInter) getInter
	(if (eq? message 'setInter) setInter
	(if (eq? message 'getEnv) getEnv
	(if (eq? message 'setEnv) setEnv
	(if (eq? message 'extendGlobalEnv) extendGlobalEnv   
	(if (eq? message 'initializeGlobalEnv) initializeGlobalEnv
	(if (eq? message 'loadFileObj1) loadFileObj1
	(if (eq? message 'loadFileObj2) loadFileObj2
	(if (eq? message 'emptyFileMsgIn) emptyFileMsgIn
	(if (eq? message 'pushFileMsgIn) pushFileMsgIn
	(if (eq? message 'popFileMsgIn) popFileMsgIn    
	(if (eq? message 'emptyFileMsgOut) emptyFileMsgOut
	(if (eq? message 'pushFileMsgOut) pushFileMsgOut
	(if (eq? message 'popFileMsgOut) popFileMsgOut    
	(if (eq? message 'addOther) addOther
	(if (eq? message 'addOtherFrom) addOtherfrom
	(if (eq? message 'getConversation) getConversation 
	(if (eq? message 'addConversation) addConversation
	(if (eq? message 'listenObj) listenObj    
	    (method-lookup super message)
	)))))))))))))))))))))))))))

      (set! self dispatch))

    self))

;;; Object fonctions ;;;

(define (new-part class) (class))

(define (display-result x) (display "Le resultat de l'valuation est : ")(display x)(newline))

(define (method-lookup object selector)
  (if (procedure? object)
      (object selector)
      (begin (display "Inapropriate object in method-lookup : ") (display object) (newline))))

(define (send object message args)
  (let ((method (method-lookup object message)))
    (if (procedure? method) 
	(apply method args)
	(if (null? method)
	    (display "Message not understood")
	    (begin (display "Inapropriate result of method-lookup : ") (display object) (newline))))))

(define (object)
  (let ((super ())
	(self ()))
    (define (dispatch message)
      ())
    (set! self dispatch)
self))

(define (print-state object)
  (newline) 
  (display "------ State of the Agent: ")(display (send object 'getName ()))(display " -----")(newline)
  (display "globalEnv: ")(print-env (send object 'getGlobalenv ()))(newline)
  (display "globalInter: ")(send object 'getGlobalInter ())(newline)
  (display "------------------Agent printed"))

;;; Converstation ;;;

(define (initialize-conversation obj1 obj2)
  (send obj1 'addOther (list obj2))
  (send obj2 'addOther (list obj1))
  (void))

(define (re-take-conversation obj1 obj2)
  (send obj1 'addOther (list obj2 obj2))
  (send obj2 'addOther (list obj1 obj1))
  (void))

(define (conversationLoop obj1 obj2)
  (let ((bool #t))
    (define (oneLoopMore)
      (newline)(display "Would you like to continue conversation loop ? -- Y or N : ")
      (let ((answer (read)))
	(if (eq? answer 'N)
	    (begin (set! bool ())(display "The end")(newline)())
	    (if (eq? answer 'Y)
		(while bool)
		(oneLoopMore)))))
    (define (while test)
	(newline)(send obj1 'listenObj ())(newline)
	(newline)(send obj2 'listenObj ())(newline)
	(oneLoopMore))
    (while bool)))

;;; KQML like message ;;;

(define (sendmessage kqmlmsg)
  (send (receiver kqmlmsg) 'pushFileMsgIn (list kqmlmsg)))

(define (print-kqmlmsg kqmlmsg)
  (display "KQMLMSG : ")
  (display (performative kqmlmsg))(display "  ")
  (display (send (sender kqmlmsg) 'getName ()))(display "  ")
  (display (send (receiver kqmlmsg) 'getName ()))(display "  ")
  (display (content kqmlmsg)))

(define (make-kqmlmsg performative sender receiver content)
  (list 'kqmlmsg performative sender receiver content))
 
(define (performative kqmlmsg) (car (cdr kqmlmsg)))
(define (sender kqmlmsg) (car (cdr (cdr kqmlmsg))))
(define (receiver kqmlmsg) (car (cdr (cdr (cdr kqmlmsg)))))
(define (content kqmlmsg) (car (cdr (cdr (cdr (cdr kqmlmsg))))))

(define kqmlmsg? (test-tag 'kqmlmsg))
