;;; xpsncf.scm  - Clement JONQUET - PhD student in Compuer Science - LIRMM - September 2003 ;;;

; This file corresponds to the SNCF experimentation main file

(load "simple.scm")
(load "ambsimple.scm")
(load "simpleobj.scm")
(newline)

;;; SNCF Agent creation ;;;

(define sncf (simpleobj))
(send sncf 'new1 (list 'sncf))
(send sncf 'loadFileObj2 (list "behaviour.scm"))
(send sncf 'loadFileObj2 (list "evalsncf.scm"))
(send sncf 'setGlobalInter (list (cdr (get-pair 'ambevaluate (send sncf 'getGlobalEnv ()) return (lambda () ())))))

(display "SNCF Agent is created...")(newline)

;;; Customer Agent creation ;;;

(define customer (simpleobj))
(send customer 'new1 (list 'customer))
(send customer 'loadFileObj2 (list "behaviour.scm"))
(send customer 'loadFileObj2 (list "evalcustomer.scm"))
(send customer 'setGlobalInter (list (cdr (get-pair 'ambevaluate (send customer 'getGlobalEnv ()) return (lambda () ())))))

(display "Customer Agent is created...")(newline)

;;; Conversation ;;;

(initialize-conversation customer sncf)
(display "Initialisation of the conversation...")(newline)(newline)

; 1st message: It defines the variables uses to construct a ticket. It corresponds to the variables and functions on which the user can interact.

(define msg1 (make-kqmlmsg 'assertion sncf customer 
			   '(define ticket-request-var 
			      '((departure string "This variable corresponds to the departure city")
				(destination string "This variable corresponds to the destination city")
				(price int "This variable corresponds to the price of the ticket (euros)")
				(date date "This variable corresponds to the date of departure")
				(class int "This variable corresponds to the ticket class, 1 or 2")
				(smoke bool "This variable corresponds to a smoker ticket or not")
				(find-ticket function "This function ask for a ticket proposition")
				(try-again function "This function ask for another proposition")))))

; 2nd message: It redefines the customer process-user-answer procedure in order to receive good answer from the customer.

(define msg2 (make-kqmlmsg 'assertion sncf customer
			   '(set! process-user-answer
				  (lambda (command)
				    (if (eq? (car command) 'find-ticket)
					(list 'kqmlmsg 'order '(find-ticket))
				    (if (eq? (car command) 'try-again)
					(list 'kqmlmsg 'order '(try-again))
				    (if (eq? (car command) 'require)
					(list 'kqmlmsg 'addTicketConstraint command))))))))

; 3rd message: It asks to the customer to execute the service function ask-user with the variables and functions defined above.
					
(define msg3 (make-kqmlmsg 'order sncf customer '(ask-user ticket-request-var)))
		
(sendmessage msg1)
(sendmessage msg2)
(sendmessage msg3)


(conversationLoop sncf customer)
;(display "Empty-env...")(print-env empty-env)(newline)(newline)
;(display "GlobalEnv de sncf...")(print-env (send sncf 'getGlobalEnv ()))(newline)(newline)(newline)
;(display "Env local de sncf...")(print-env (send sncf 'getEnv (list (send customer 'getName ()))))(newline)(newline)(newline)
;(display "GlobalEnv de customer...")(print-env (send customer 'getGlobalEnv ()))(newline)(newline)
;(display "Env local de customer...")(print-env (send customer 'getEnv (list (send sncf 'getName ()))))(newline)(newline)
;(display "GlobalInter de customer...")(print-proc (send customer 'getGlobalInter ()))(newline)(newline)
;(display "Inter local de customer...")(print-proc (send customer 'getInter (list (send sncf 'getName ()))))(newline)(newline)
